/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	
dojo.provide("jazz.core.internal.CSSLoader");

jazz.core.internal.CSSLoader.loadCSS = function(/*String*/ styleURL) {
	var d = new dojo.Deferred();
	var headers = {};
	headers["accept"] = "text/json";
	headers["content-type"] = "application/x-www-form-urlencoded; charset=utf-8";
	var self = this;
	var bindArgs = {
		url: styleURL,
		handleAs: "json",
		headers: headers,
		handle: function(cssModules, ioArgs) {
			if (cssModules instanceof Error) {
				d.errback(cssModules);
			}
			else {
				jazz.core.internal.CSSLoader._loadCSSModules(cssModules);
				d.callback();
			}
		}
	};
	var xhr = dojo.xhrGet(bindArgs);
	
	return d;
};

jazz.core.internal.CSSLoader._loadCSSModules = function(cssModules) {
	var ruleCount = 0;
	var cssModulesText = "";
	var cssModule = null;
	if (cssModules !== null && cssModules.length > 0) {
		
		if (djConfig.isDebug) {	var start = new Date().getTime(); }
		
		for (var i = 0; i < cssModules.length; i++) {
			for (var j = 0; j < cssModules[i].u.length; j++) {
				cssModule = net.jazz.ajax.core.internal.style.CSSModuleMap.findCSSModule(cssModules[i].u[j]);
				if (cssModule !== undefined) {
					cssModule.l = true;
				}
			}
			ruleCount += cssModules[i].rc;
			cssModulesText += cssModules[i].c;
		}
		jazz.core.internal.CSSLoader._loadStyleSheet(cssModulesText, ruleCount);
		
		if (djConfig.isDebug) {	console.debug("time to load CSS ["+(new Date().getTime() - start)+"]");	}
	}
};

jazz.core.internal.CSSLoader._loadStyleSheet = function(cssModulesText, rulecount) {
	if (document.createStyleSheet === undefined) {
		var styleElement = document.createElement("style");
		styleElement.appendChild(document.createTextNode(cssModulesText));
		document.getElementsByTagName("head")[0].appendChild(styleElement);
	}
	else {
		var styleSheet = null;
		if (document.styleSheets.length > 31) {
			for (var i = 0; i < document.styleSheets.length; i++) {
				if (document.styleSheets[i].rules.length + rulecount < 4096) {
					styleSheet = document.styleSheets[i];
					break;
				}
			}	
		}
		else {
			if (djConfig.isDebug) { console.debug("Creating new stylesheet"); }
			styleSheet = document.createStyleSheet();
		}
		if (styleSheet !== null) {
			if (djConfig.isDebug) { console.debug("stylesheet currently has "+styleSheet.rules.length+" rules"); }
			styleSheet.cssText += cssModulesText;
			if (djConfig.isDebug) {	console.debug("stylesheet now has " + styleSheet.rules.length + " rules"); }
		}
		else {
			new Error("No stylesheet is available to support "+rulecount+" rules");	
		}	
	}
};
	
})();
