/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.app.internal.loginUtil");

dojo.require("dojo.cookie");

dojo.requireLocalization("jazz.app.internal", "LoginWidgetMessages");

jazz.app.internal.loginUtil.getLoginMode = function() {
	var mode = "page";
	
	try {
		if (top.location.href !== window.location.href) {
			mode = "frame";
		}
	} catch (e) {
		// if you're in an iframe in a different domain, the top.location check
		// results in a security exception
		mode = "frame";
	}
	
	// mode override for testing
	if(location.search && location.search.indexOf("testTextualLogin=true") !== -1) {
		mode = "frame";
	}
	
	//console.warn("mode: " + mode + ", top.location.href: " + top.location.href + ", window.location.href: " + window.location.href);
	return mode;
};

jazz.app.internal.loginUtil.getLocationHash = function() {
	var result = window.location.hash;
	if (result)
		return result;
	result = window.document.URL;
	var index = result.indexOf('#');
	if (index > 0)
		return result.substr(index);
	return "";
};

jazz.app.internal.loginUtil.insertLoginLink = function(parentNode) {
	var tmpSpan = document.createElement("span");
	var messages = dojo.i18n.getLocalization("jazz.app.internal", "LoginWidgetMessages");
	tmpSpan.innerHTML = dojo.string.substitute(messages.loginLinkText, [window.location.hostname]);
	var loginLink = tmpSpan.getElementsByTagName("a")[0];
	while(tmpSpan.hasChildNodes()) {
		parentNode.appendChild(tmpSpan.removeChild(tmpSpan.firstChild))
	}
	return loginLink;
}

jazz.app.internal.loginUtil.getUserIdCookie = function() {
	return dojo.cookie("net-jazz-ajax-cookie-rememberUserId");
};

jazz.app.internal.loginUtil.setUserIdCookie = function(userId) {
	dojo.cookie("net-jazz-ajax-cookie-rememberUserId", userId, {path: net.jazz.ajax._contextRoot});
};
